CON

  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

  const         = 6

OBJ

  rpc           : "rpc_host"

PUB start

  cognew(@client, rpc.start)

DAT

'-------[ Calling program ]----------------------------------------------------

              org       0

client        jmp       #startup                'Jump to startup. (Later, holds saved Z flag in bit 0.)

'Jump table: Identical entries, one for each available routine in host.

              jmpret    cmdvalue,#cmdset        'Put command + 1 into cmdvalue source field; jump to cmdset.
              jmpret    cmdvalue,#cmdset        'Put command + 1 into cmdvalue source field; jump to cmdset.

'Set up and execute remote procedure call.

cmdset        wrlong    cmdvalue,par            'Write it to command central (hub).
              muxnz     client,#1               'Save the non-Z flag in (now unused) client bit 0.
         
'Wait for return.              

waitret       rdlong    cmdvalue,par wz         'Has remote procedure returned?
        if_nz jmp       #waitret                '  No:  Keep checking.
        
              test      client,#1 wz            '  Yes: Restore the Z flag.
rpcall        ret                               '       Return to caller.

'Initialization.
              
startup       mov       parmaddr,par            'Save the parameter address (not used in this example.)
              add       parmaddr,#4

'Main program code.

mainloop      jmpret    rpcall,#rpc#SET         'Call the remote set routine.
              jmpret    rpcall,#rpc#CLR         'Call the remote set routine.
              jmp       #mainloop               'Loop back.

'Variables.

cmdvalue      res       1
parmaddr      res       1  

