CON

  SET           = 1             'Set command.
  CLR           = 2             'Clr command.

PUB start

  cognew(@host, @instrbuf)      'Start the host service.
  return @instrbuf              'Return the command buffer address.

DAT

'-------[ Command and parameter buffer ]---------------------------------------

instrbuf      long      0                       'Command buffer.
              long      0                       'Parameter buffer.

'-------[ Called program ]-----------------------------------------------------

              org       0

'Jump table.
              
host          jmp       #setup                  'Go do setup first. (Becomes "jmp #waitcmd" after setup.)  
              long      0                       'Dummy placeholder, since command is now value + 1 .
              jmp       #setpin                 'Address of set routine.
              jmp       #clrpin                 'Address of clr routine.

'Initialization.
                            
setup         mov       argaddr,par             'Save parameter address (not used in this example).
              add       argaddr,#4
              mov       dira,#1                 'Enable pin A0 output.
              movs      host,#waitcmd           'Make command zero (NOP) point back to waitcmd.
              jmp       #waitcmd                'Start the dispatcher.

'Procedure return.
        
rpret         wrlong    done,par                'Return from remote call. Tell client.

'Call dispatcher.
              
waitcmd       rdlong    command,par             'Get the command.
              jmp       command                 'Jump to it via jump table.

'Remote procedures.

setpin        mov       outa,#1
              jmp       #rpret

clrpin        mov       outa,#0
              jmp       #rpret

'Constant and variable.

done          long      0

command       res       1
argaddr       res       1
              